import { select, arc } from 'd3';

export const renderDarumaFace = () => {

  // Selecting svg element in html and 
  // adding <g></g> group elements within it
  const gUpdate = select('svg')
      .selectAll('g')
      .data([null]);

  const gEnter = gUpdate
      .enter()
      .append('g');

  // Add background-color style
  select('#canvas').style('background-color', '#E4BD00');

  // Change canvas background color from orange to light blue
  // after 20 seconds of the page loaded
  const t = d3.transition()
     .duration(5000);
  d3.select("#canvas")
     .transition(t)
     .style("background-color", "lightblue");


  const canvasWidth = +select('#canvas').attr('width');
  const canvasHeight = +select('#canvas').attr('height');

  const gRectEnter = gEnter
      .append('rect')
      .attr('x', 10)
      .attr('y', 10)
      .attr('width', canvasWidth - 20)
      .attr('height', canvasHeight - 20)
      .attr('fill', 'none')
      .attr('stroke', 'none')
      ;

  // Add "left eye" 
  const gCircleLeftEye = gEnter.append('circle')
        .attr('r', 50)
        .attr('cx', 120)
        .attr('cy', 120)
        .attr('fill', 'black')
        // .attr('stroke', 'black')
        ;
  // Add "right eye"
  const gCircleRightEye = gEnter.append('circle')
        .attr('r', 50)
        .attr('cx', canvasWidth - 120)
        .attr('cy', 120)
        .attr('fill', 'black')
        // .attr('stroke', 'black')
        ;

  // Smile left eyeball 
  const gPathLeftEyeball = gEnter
        .append('g')
        .attr('transform', 'translate(140, 100) rotate(90)') 
        .append('path')
        .attr('fill', 'white')
        .attr('d', arc()({
          innerRadius: 0,
          outerRadius: 20,
          startAngle: -Math.PI/2,
          endAngle: Math.PI / 2 * 3//Math.PI - Math.PI/4
        }))
        ;

  const gPathRightEyeball = gEnter
        .append('g')
        .attr('transform', 'translate(350, 120) rotate(90)') 
        .append('path')
        .attr('fill', 'white')
        .attr('d', arc()({
          innerRadius: 0,
          outerRadius: 20,
          startAngle: -Math.PI/2,
          endAngle: Math.PI / 2 * 3//Math.PI - Math.PI/4
        }))
        ;

  // // Smile left eyeball 
  // const gPathLeftEyeball = gEnter
  // 			.append('g')
  // 			.attr('transform', 'translate(120, 120) rotate(90)') 
  // 			.append('path')
  // 			.attr('fill', 'white')
  // 			.attr('d', arc()({
  //         innerRadius: 15,
  //         outerRadius: 30,
  //         startAngle: -Math.PI/2,
  //         endAngle: -1 * Math.PI / 2 * 3//Math.PI - Math.PI/4
  // 			}))
  // 			;
  // // Smile right eyeball 
  // const gPathRightEyeball = gEnter
  // 			.append('g')
  // 			.attr('transform', 'translate(380, 120) rotate(-10)') // ${canvasWidth} - 120
  // 			.append('path')
  // 			.attr('fill', 'white')
  // 			.attr('d', arc()({
  //         innerRadius: 15,
  //         outerRadius: 30,
  //         startAngle: -Math.PI/2,
  //         endAngle: -1 * Math.PI / 2 * 3//Math.PI - Math.PI/4
  // 			}))
  // 			;
  // 
  const gCircleEyebrowEx = gEnter.append('circle')
        .attr('r', 10)
        .attr('cx', 220)
        .attr('cy', 60)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleEyebrowEx2 = gEnter.append('circle')
        .attr('r', 10)
        .attr('cx', 300)
        .attr('cy', 70)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  // Face blush
  const gCircleFaceBlushLeft = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 120)
        .attr('cy', 250)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleFaceBlushLeft2 = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 120 - 20)
        .attr('cy', 250 + 20)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleFaceBlushLeft3 = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 120 - 40)
        .attr('cy', 250 + 10)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleFaceBlushRight = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 380)
        .attr('cy', 250)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleFaceBlushRight2 = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 380 + 20)
        .attr('cy', 250 + 20)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  const gCircleFaceBlushRight3 = gEnter.append('circle')
        .attr('r', 6)
        .attr('cx', 380 + 40)
        .attr('cy', 250 - 20)
        .attr('fill', '#A10100')
        .attr('stroke', 'none');
  // Add noses
  const gCircle3 = gEnter.append('circle')
        .attr('r', 50)
        .attr('cx', canvasWidth/2)
        .attr('cy', canvasHeight/2 - 20)
        .attr('fill', '#A10100')
        .attr('stroke', 'black');

  const gCircle4 = gEnter.append('circle')
        .attr('r', 40)
        .attr('cx', canvasWidth/2 + 20 * 1.5)
        .attr('cy', canvasHeight/2 - 10)
        .attr('fill', '#A10100')
        .attr('stroke', 'black');

  const gCircle5 = gEnter.append('circle')
        .attr('r', 30)
        .attr('cx', canvasWidth/2 + 20 * 3)
        .attr('cy', canvasHeight/2 - 5)
        .attr('fill', '#A10100')
        .attr('stroke', 'black');

  const gCircle6 = gEnter.append('circle')
        .attr('r', 20)
        .attr('cx', canvasWidth/2 + 20 * 4.5)
        .attr('cy', canvasHeight/2)
        .attr('fill', '#A10100')
        .attr('stroke', 'black');

  // Add mouth
  // const gCircle7 = gEnter.append('circle')
  // 			.attr('r', 20)
  // 			.attr('cx', canvasWidth/2 - 10 * 5)
  // 			.attr('cy', canvasHeight - 120)
  // 			.attr('fill', 'grey')
  // 			.attr('stroke', 'black');

  // const gArc1 = gEnter
  // 			.append('g')
  // 			.attr('transform', 'translate(canvasWidth/2 - 50, canvasHeight -  120)')
  // 			.append('path')
  // 			.attr('fill', 'red')
  // 			.attr('d', arc()({
  //       	innerRadius: 80,
  //         outerRadius: 100,
  //         startAngle: Math.PI/2,
  //         endAngle: Math.PI
  //       }));

  const x = 300, y = 100;

  // Mouth
  const gPathMouth = gEnter
      .append('g')
      .attr('transform', 'translate(250, 380)')
      .append('path')
      .attr('fill', '#B01200')
      .attr('d', arc()({
        innerRadius: 80,
        outerRadius: 100,
        startAngle: -1 * Math.PI/2,
        endAngle: -1 * Math.PI/2 * 3
      }))
      ;
  // Right tone
  const gPathTone = gEnter
      .append('g')
      .attr('transform', 'translate(290, 435) rotate(-10)')
      .append('path')
      .attr('fill', '#B01200')
      .attr('d', arc()({
        innerRadius: 24,
        outerRadius: 30,
        startAngle: Math.PI/2 * 3,
        endAngle: Math.PI * 2.5 
      }))
      ;
  // Left tone
  const gPathTone2 = gEnter
      .append('g')
      .attr('transform', 'translate(240, 450) rotate(-30)')
      .append('path')
      .attr('fill', '#B01200')
      .attr('d', arc()({
        innerRadius: 24,
        outerRadius: 30,
        startAngle: Math.PI/2 *3,
        endAngle: Math.PI * 2.5 
      }))
      ;

  // // Left Mouth
  // const gPathLeftMouth = gEnter
  // 			.append('g')
  // 			.attr('transform', 'translate(250, 380)')
  // 			.append('path')
  // 			.attr('fill', 'black')
  // 			.attr('d', arc()({
  //         innerRadius: 80,
  //         outerRadius: 100,
  //         startAngle: -1 * Math.PI/2,
  //         endAngle: -1 * Math.PI
  // 			}))
  // 			;
  // // Right Mouth
  // const gPathRightMouth = gEnter
  // 			.append('g')
  // 			.attr('transform', 'translate(250, 380)')
  // 			.append('path')
  // 			.attr('fill', 'black')
  // 			.attr('d', arc()({
  //         innerRadius: 80,
  //         outerRadius: 100,
  //         startAngle: Math.PI/2,
  //         endAngle: Math.PI
  // 			}))
  // 			;
  // Left Eyebrow
  const gPathLeftEyebrow = gEnter
        .append('g')
        .attr('transform', 'translate(120, 120)')
        .append('path')
        .attr('fill', '#A10100')
        .attr('d', arc()({
          innerRadius: 80,
          outerRadius: 100,
          startAngle: -1 * Math.PI/4,
          endAngle: Math.PI/4
        }))
        ;
  // Right Eyebrow
  const gPathRightEyebrow = gEnter
        .append('g')
        .attr('transform', 'translate(380, 120)') // ${canvasWidth} - 120
        .append('path')
        .attr('fill', '#A10100')
        .attr('d', arc()({
          innerRadius: 80,
          outerRadius: 100,
          startAngle: -1 * Math.PI/4,
          endAngle: Math.PI/4
        }))
        ;
  // Left shave
  const gPathLeftShave = gEnter
        .append('g')
        .attr('transform', 'translate(120, 295) rotate(-30)')
        .append('path')
        .attr('fill', '#5A1200')
        .attr('d', arc()({
          innerRadius: 80,
          outerRadius: 100,
          startAngle: Math.PI/4 * 3,
          endAngle: Math.PI / 6 + Math.PI 
        }))
        ;
  // Right shave
  const gPathRightShave = gEnter
        .append('g')
        .attr('transform', 'translate(380, 295) rotate(40)')
        .append('path')
        .attr('fill', '#5A1200')
        .attr('d', arc()({
          innerRadius: 80,
          outerRadius: 100,
          startAngle: Math.PI/4 * 3,
          endAngle: Math.PI / 6 + Math.PI 
        }))
        ;
  // List container #message-tag
  // const list_container = select('#message-tag');
  // list_container.style('background-color', 'pink');
}